CartoPlus_PointList = { };
RegisterForSave("CartoPlus_PointList");

CartoPlus_NumberPoint = 0;
CartoPlus_LastClickTime = 0;
CartoPlus_CurrentIcon = 0;
CartoPlus_OpenPoint = 0;

CartoPlus_IconList = { };
CartoPlus_IconList[1] = "Interface\\AddOns\\CartoPlus\\Skin\\IconBlanc";
CartoPlus_IconList[2] = "Interface\\AddOns\\CartoPlus\\Skin\\IconGris";
CartoPlus_IconList[3] = "Interface\\AddOns\\CartoPlus\\Skin\\IconJaune";
CartoPlus_IconList[4] = "Interface\\AddOns\\CartoPlus\\Skin\\IconOrange";
CartoPlus_IconList[5] = "Interface\\AddOns\\CartoPlus\\Skin\\IconRouge";
CartoPlus_IconList[6] = "Interface\\AddOns\\CartoPlus\\Skin\\IconVert";
CartoPlus_IconList[7] = "Interface\\AddOns\\CartoPlus\\Skin\\IconBleuTurquoise";
CartoPlus_IconList[8] = "Interface\\AddOns\\CartoPlus\\Skin\\IconBleuFonce";

CartoPlus_IconList[9] = "Interface\\AddOns\\CartoPlus\\Skin\\CarreJaune";
CartoPlus_IconList[10] = "Interface\\AddOns\\CartoPlus\\Skin\\CarreRose";
CartoPlus_IconList[11] = "Interface\\AddOns\\CartoPlus\\Skin\\CarreVert";
CartoPlus_IconList[12] = "Interface\\AddOns\\CartoPlus\\Skin\\CarreViolet";
CartoPlus_IconList[13] = "Interface\\AddOns\\CartoPlus\\Skin\\CroixJaune";
CartoPlus_IconList[14] = "Interface\\AddOns\\CartoPlus\\Skin\\CroixRose";
CartoPlus_IconList[15] = "Interface\\AddOns\\CartoPlus\\Skin\\CroixVerte";
CartoPlus_IconList[16] = "Interface\\AddOns\\CartoPlus\\Skin\\CroixViolette";

CartoPlus_ZoneList = { };
CartoPlus_ZoneList[101] = "Ashenvale";
CartoPlus_ZoneList[102] = "Azshara";
CartoPlus_ZoneList[103] = "Darkshore";
CartoPlus_ZoneList[104] = "Darnassus";
CartoPlus_ZoneList[105] = "Desolace";
CartoPlus_ZoneList[106] = "Durotar";
CartoPlus_ZoneList[107] = "Dustwallow Marsh";
CartoPlus_ZoneList[108] = "Felwood";
CartoPlus_ZoneList[109] = "Feralas";
CartoPlus_ZoneList[110] = "Moonglade";
CartoPlus_ZoneList[111] = "Mulgore";
CartoPlus_ZoneList[112] = "Orgrimmar";
CartoPlus_ZoneList[113] = "Silithus";
CartoPlus_ZoneList[114] = "Stonetalon Mountains";
CartoPlus_ZoneList[115] = "Tanaris";
CartoPlus_ZoneList[116] = "Teldrassil";
CartoPlus_ZoneList[117] = "The Barrens";
CartoPlus_ZoneList[118] = "Thousand Needles";
CartoPlus_ZoneList[119] = "Thunder Bluff";
CartoPlus_ZoneList[120] = "Un'Goro Crater";
CartoPlus_ZoneList[121] = "Winterspring";

CartoPlus_ZoneList[201] = "Alterac Mountains";
CartoPlus_ZoneList[202] = "Arathi Highlands";
CartoPlus_ZoneList[203] = "Badlands";
CartoPlus_ZoneList[204] = "Blasted Lands";
CartoPlus_ZoneList[205] = "Burning Steppes";
CartoPlus_ZoneList[206] = "Deadwind Pass";
CartoPlus_ZoneList[207] = "Dun Morogh";
CartoPlus_ZoneList[208] = "Duskwood";
CartoPlus_ZoneList[209] = "Eastern Plaguelands";
CartoPlus_ZoneList[210] = "Elwynn Forest";
CartoPlus_ZoneList[211] = "Hillsbrad Foothills";
CartoPlus_ZoneList[212] = "Ironforge";
CartoPlus_ZoneList[213] = "Loch Modan";
CartoPlus_ZoneList[214] = "Redridge Mountains";
CartoPlus_ZoneList[215] = "Searing Gorge";
CartoPlus_ZoneList[216] = "Silverpine Forest";
CartoPlus_ZoneList[217] = "Stormwind City";
CartoPlus_ZoneList[218] = "Stranglethorn Vale";
CartoPlus_ZoneList[219] = "Swamp of Sorrows";
CartoPlus_ZoneList[220] = "The Hinterlands";
CartoPlus_ZoneList[221] = "Tirisfal Glades";
CartoPlus_ZoneList[222] = "Undercity";
CartoPlus_ZoneList[223] = "Western Plaguelands";
CartoPlus_ZoneList[224] = "Westfall";
CartoPlus_ZoneList[225] = "Wetlands";


function CartoPlus_OnLoad()
	if (Cosmos_RegisterChatWatch) then
		Cosmos_RegisterChatWatch ( "CARTOPLUSPARTY", {CHANNEL_PARTY}, function (type, info, arg1, arg2, arg3, arg4) CartoPlus_ProcessMessage(0, arg1, arg2); end );
		Cosmos_RegisterChatWatch ( "CARTOPLUSCOSMOS", {CHANNEL_COSMOS}, function (type, info, arg1, arg2, arg3, arg4) CartoPlus_ProcessMessage(1, arg1, arg2); end );
	end
	if ( Cosmos_RegisterChatCommand ) then
--		Cosmos_RegisterChatCommand (
--			"CARTOPLUS_MARK",
--			CARTOPLUS_MARK,
--			CartoPlus_Mark,
--			CARTOPLUS_MARK_INFO
--		);
	end
	if (Cosmos_AfterInit) then
		Cosmos_AfterInit(CartoPlus_AfterInit);
	end
end

function CartoPlus_AfterInit()
	if (type(CT_UserMap_Notes) == "table") then
		for i = 1, table.getn(CT_UserMap_Notes), 1 do
			CartoPlus_Point_Make(CartoPlus_GetZoneNumber(CT_UserMap_Notes[i].zone), CT_UserMap_Notes[i]["x"], CT_UserMap_Notes[i]["y"], CT_UserMap_Notes[i]["desc"], "\n|cFFFF0000Loaded from CTMapMod|r", 1);
		end
		print1("Notes from CTMapMod are succesfully loaded into CartoPlus");
	end
	CT_UserMap_Notes = nil;
	WorldMapMagnifyingGlassButton:SetText(WorldMapMagnifyingGlassButton:GetText().."\n"..CARTOPLUS_INSTRUCTION);
end

function CartoPlus_GetZoneNumber(zone)
	for i = 1, 21, 1 do
		if (CartoPlus_ZoneList[100+i] == zone) then
			zone = 100+i;
			break;
		end
	end
	for i = 1, 25, 1 do
		if (CartoPlus_ZoneList[200+i] == zone) then
			zone = 200+i;
			break;
		end
	end
	return zone;
end

function CartoPlus_Mark(msg)
	if (GetCurrentMapContinent() ~= 0 and GetCurrentMapZone() ~= 0) then
		local MapNumber = GetCurrentMapContinent() * 100 + GetCurrentMapZone();
		local px, py = GetPlayerMapPosition("player");
		CartoPlus_OpenPoint = 1;
		CartoPlus_Point_Make(MapNumber, px, py, msg, "Temp Note");
		CartoPlus_ShowMap(MapNumber);
	else
		local number = CartoPlus_GetZoneNumber(GetZoneText());
		if (number > 200) then
			number = number - 200;
		else
			number = number - 100;
		end
		SetMapZoom(GetContinentNumber(), number);
		Cosmos_Schedule(0.5, CartoPlus_Mark, msg);
	end
end

function CartoPlus_ProcessMessage(type, msg, who)
	if (who ~= UnitName("player")) then
		if (type == 1) then -- Cosmos
			if (strsub(msg, 1, 8) == "<Carto+>") then
				local data = split(strsub(msg, 9, strlen(msg)), "`");
				-- player, zone, x, y, title, expla, icon
				if (strupper(data[1]) == strupper(UnitName("player"))) then
					CartoPlus_Point_Make(data[2], data[3], data[4], data[5], data[6].."\n\n|cFFFF0000"..format(CARTOPLUS_RECEIVEDTAG, who).."|r", data[7] * 1);
					Print(format(CARTOPLUS_RECEIVEDNOTE, MakeHyperLink("Player:"..who, who), MakeHyperLink("Carto+:"..data[2], CartoPlus_ZoneList[data[2]*1], "FF0000"), data[5]));
				end
				if (WorldMapFrame:IsVisible()) then
					CartoPlus_Points_Clear();
					CartoPlus_Points_Set();
				end
			end
		elseif (type == 0) then -- Party
			if (strsub(msg, 1, 8) == "<Carto+>") then
				local data = split(strsub(msg, 9, strlen(msg)), "`");
				-- zone, x, y, title, expla, icon
				CartoPlus_Point_Make(data[1], data[2], data[3], data[4], data[5].."\n\n|cFFFF0000"..format(CARTOPLUS_RECEIVEDTAG, who).."|r", data[6] * 1);
				Print(format(CARTOPLUS_RECEIVEDNOTE, MakeHyperLink("Player:"..who, who), MakeHyperLink("Carto+:"..data[1], CartoPlus_ZoneList[data[1]*1], "FF0000"), data[4]));
				if (WorldMapFrame:IsVisible()) then
					CartoPlus_Points_Clear();
					CartoPlus_Points_Set();
				end
			end
		end
	end
end


-- World Map -->

function CartoPlus_ShowMap(number)
	ShowUIPanel(WorldMapFrame);
	UIDropDownMenu_SetSelectedID(WorldMapZoneDropDown, strsub(number, 2, 3));
	SetMapZoom(strsub(number, 1, 1), strsub(number, 2, 3));
end

old_WorldMapFrame_Update = WorldMapFrame_Update;
function WorldMapFrame_Update()
	old_WorldMapFrame_Update();
	CartoPlus_Points_Clear();
	CartoPlus_Points_Set();
end

old_WorldMapButton_OnClick = WorldMapButton_OnClick;
function WorldMapButton_OnClick(mouseButton, button)
	if (CartoPlus_Modify:IsVisible()) then return; end
	if (CartoPlus_Send:IsVisible()) then return; end
	local oldzone = GetCurrentMapContinent() * 100 + GetCurrentMapZone();
	
	old_WorldMapButton_OnClick(mouseButton, button);
	
	if ( mouseButton == "LeftButton" ) then
		local newzone = GetCurrentMapContinent() * 100 + GetCurrentMapZone();
		if ( oldzone ~= 0 and newzone == oldzone ) then -- New point
			if (GetTime() < CartoPlus_LastClickTime + 0.5) then
				local vis = 0;
				if (WorldMapFrameAreaLabel:IsVisible()) then
					vis = 1;
					WorldMapFrameAreaLabel:Hide();
				end
				local x, y = CartoPlus_GetRealXY();
				CartoPlus_Point_Make(newzone, x, y, CARTOPLUS_UNNAMEDTITLE, CARTOPLUS_UNNAMEDEXPLA, 1);
				CartoPlus_LastClickTime = 0;
				if (vis == 1) then
					WorldMapFrameAreaLabel:Show();
				end
			else
				CartoPlus_LastClickTime = GetTime();
			end
		end
	end
	if (oldzone ~= newzone) then -- New map
		CartoPlus_Points_Clear();
		CartoPlus_Points_Set();
	end
end

function CartoPlus_GetRealXY(x, y)
	local set = 0;
	if (x) then set = 1; end
	if (set == 0) then
		x, y = GetCursorPosition();
	end
	local scale = WorldMapFrame:GetScale();
	
	x = x / scale;
	y = y / scale;
	
	local width = WorldMapButton:GetWidth();
	local height = WorldMapButton:GetHeight();
	local centerX, centerY = WorldMapFrame:GetCenter();
	
	if (not centerX) then
		centerX = width / 2;
	end
	
	if (not centerY) then
		centerY = height / 2;
	end
	
	local adjustedX = (x - (centerX - (width/2))) / width;
	local adjustedY = (centerY + (height/2) - y) / height;
	
	adjustedY = adjustedY -0.0285;
	adjustedX = adjustedX +0.001;
	
	return adjustedX, adjustedY;
end


-- Points -->

function CartoPlus_ToolTip_SetText(title, expla)
	CartoPlus_Tooltip:SetText(title);
	local oldwidth = CartoPlus_Tooltip:GetWidth();
	local oldheight = CartoPlus_Tooltip:GetHeight();
	
	CartoPlus_Tooltip:SetText(title.."\n"..expla);
	
	width = CartoPlus_Tooltip:GetWidth() * 12 / 14 + 7;
	height = CartoPlus_Tooltip:GetHeight() * 12 / 14 + 7;
	
	CartoPlus_Tooltip:SetText(title);
	if (CartoPlus_Tooltip:GetWidth() < oldwidth) then width = oldwidth; end
	if (width < oldwidth) then width = oldwidth; end
	
	CartoPlus_TooltipTextLeft2:SetText(expla);
	CartoPlus_TooltipTextLeft2:Show();
	CartoPlus_Tooltip:Show();
	CartoPlus_Tooltip:SetWidth(width);
	CartoPlus_Tooltip:SetHeight(height);
end

function CartoPlus_Point_OnLoad()
	this:SetFrameLevel(this:GetFrameLevel() + 1);
	this:RegisterForClicks("LeftButtonUp", "RightButtonUp");
end

function CartoPlus_Point_OnEnter()
	local x, y = this:GetCenter();
	local parentX, parentY = WorldMapButton:GetCenter();
	if ( x > parentX ) then
		CartoPlus_Tooltip:SetOwner(this, "ANCHOR_LEFT");
	else
		CartoPlus_Tooltip:SetOwner(this, "ANCHOR_RIGHT");
	end
	local MapNumber = GetCurrentMapContinent() * 100 + GetCurrentMapZone();
	CartoPlus_ToolTip_SetText(CartoPlus_PointList[MapNumber][this:GetID()].title, CartoPlus_PointList[MapNumber][this:GetID()].expla);
end

function CartoPlus_Point_OnLeave()
	CartoPlus_Tooltip:Hide();
end

function CartoPlus_Point_OnClick(mousebutton, button)
	if (not button) then button = this; end
	if (mousebutton == "RightButton") then
		if (CartoPlus_Modify:IsVisible()) then return; end
		if (CartoPlus_Send:IsVisible()) then return; end
		
		local x, y = button:GetCenter();
		local parentX, parentY = WorldMapButton:GetCenter();
		CartoPlus_Modify:ClearAllPoints();
		if ( x > parentX and y > parentY ) then
			CartoPlus_Modify:SetPoint("TOPRIGHT", button:GetName(), "BOTTOMLEFT", 0, 0);
		elseif ( x < parentX and y > parentY ) then
			CartoPlus_Modify:SetPoint("TOPLEFT", button:GetName(), "BOTTOMRIGHT", 0, 0);
		elseif ( x > parentX and y < parentY ) then
			CartoPlus_Modify:SetPoint("BOTTOMRIGHT", button:GetName(), "TOPLEFT", 0, 0);
		elseif ( x < parentX and y < parentY ) then
			CartoPlus_Modify:SetPoint("BOTTOMLEFT", button:GetName(), "TOPRIGHT", 0, 0);
		end
		
		local MapNumber = GetCurrentMapContinent() * 100 + GetCurrentMapZone();
		
		CartoPlus_ModifyTitle:SetText(CartoPlus_PointList[MapNumber][button:GetID()].title);
		CartoPlus_ModifyExplanation:SetText(CartoPlus_PointList[MapNumber][button:GetID()].expla);
		CartoPlus_Point_Click(CartoPlus_PointList[MapNumber][button:GetID()].icon);
		CartoPlus_Modify.id = button:GetID();
		CartoPlus_Modify:Show();

	elseif (mousebutton == "LeftButton") then
		if (Cosmos_SendPartyMessage) then
			if (CartoPlus_Modify:IsVisible()) then return; end
			if (CartoPlus_Send:IsVisible()) then return; end

			local x, y = button:GetCenter();
			local parentX, parentY = WorldMapButton:GetCenter();
			CartoPlus_Send:ClearAllPoints();
			if ( x > parentX and y > parentY ) then
				CartoPlus_Send:SetPoint("TOPRIGHT", button:GetName(), "BOTTOMLEFT", 0, 0);
			elseif ( x < parentX and y > parentY ) then
				CartoPlus_Send:SetPoint("TOPLEFT", button:GetName(), "BOTTOMRIGHT", 0, 0);
			elseif ( x > parentX and y < parentY ) then
				CartoPlus_Send:SetPoint("BOTTOMRIGHT", button:GetName(), "TOPLEFT", 0, 0);
			elseif ( x < parentX and y < parentY ) then
				CartoPlus_Send:SetPoint("BOTTOMLEFT", button:GetName(), "TOPRIGHT", 0, 0);
			end
			CartoPlus_SendTitle:SetText("");
			CartoPlus_Send.id = button:GetID();
			CartoPlus_Send:Show();
		end
	end
end

function CartoPlus_Points_Clear()
	for i = 1, CartoPlus_NumberPoint + 1, 1 do
		getglobal("CartoPlus_Point"..i):Hide();
	end
	CartoPlus_NumberPoint = 0;
end

function CartoPlus_Points_Set()
	local MapNumber = GetCurrentMapContinent() * 100 + GetCurrentMapZone();
	if (CartoPlus_PointList[MapNumber]) then
		for i, v in CartoPlus_PointList[MapNumber] do
			CartoPlus_Point_Set(i, CartoPlus_PointList[MapNumber][i].x, CartoPlus_PointList[MapNumber][i].y, CartoPlus_PointList[MapNumber][i].icon)
		end
	end
	if (CartoPlus_OpenPoint == 1) then
		local number = table.getn(CartoPlus_PointList[MapNumber]);
		CartoPlus_Point_OnClick("RightButton", getglobal("CartoPlus_Point"..number));
		CartoPlus_OpenPoint = 0;
	end
end

function CartoPlus_Point_Set(id, x, y, icon)
	getglobal("CartoPlus_Point"..id):ClearAllPoints();
	getglobal("CartoPlus_Point"..id):SetPoint("CENTER", "WorldMapDetailFrame", "TOPLEFT", x * WorldMapButton:GetWidth(), -y * WorldMapButton:GetHeight());
	getglobal("CartoPlus_Point"..id):Show();
	getglobal("CartoPlus_Point"..id.."Icon"):SetTexture(CartoPlus_IconList[icon]);
	CartoPlus_NumberPoint = CartoPlus_NumberPoint + 1;
end

function CartoPlus_Point_Make(zone, x, y, title, expla, icon, id)
	zone = zone * 1;
	if (not CartoPlus_PointList[zone]) then
		CartoPlus_PointList[zone] = { };
	end
	if (not icon) then 
		icon = 1;
	end
	if (not id) then
		id = table.getn(CartoPlus_PointList[zone]) + 1;
		CartoPlus_PointList[zone][id] = { };
	end
	CartoPlus_PointList[zone][id].x = x;
	CartoPlus_PointList[zone][id].y = y;
	CartoPlus_PointList[zone][id].title = title;
	CartoPlus_PointList[zone][id].expla = expla;
	CartoPlus_PointList[zone][id].icon = icon;
	
	CartoPlus_Point_Set(id, x, y);
end

function CartoPlus_Point_Delete()
	local MapNumber = GetCurrentMapContinent() * 100 + GetCurrentMapZone();
	CartoPlus_Modify:Hide();
	local temp = { };
	i = 0;
	for k, v in CartoPlus_PointList[MapNumber] do
		if (k ~= CartoPlus_Modify.id) then
			i = i + 1;
			temp[i] = v;
		end
	end
	CartoPlus_PointList[MapNumber] = temp;
	
	CartoPlus_Points_Clear();
	CartoPlus_Points_Set();
end

function CartoPlus_Point_Modify() 
	CartoPlus_Modify:Hide();
	
	local MapNumber = GetCurrentMapContinent() * 100 + GetCurrentMapZone();
	CartoPlus_PointList[MapNumber][CartoPlus_Modify.id].title = CartoPlus_ModifyTitle:GetText();
	CartoPlus_PointList[MapNumber][CartoPlus_Modify.id].expla = CartoPlus_ModifyExplanation:GetText();
	CartoPlus_PointList[MapNumber][CartoPlus_Modify.id].icon = CartoPlus_CurrentIcon;
	
	CartoPlus_Points_Clear();
	CartoPlus_Points_Set();
end

function CartoPlus_Point_SendPlayer()
	local MapNumber = GetCurrentMapContinent() * 100 + GetCurrentMapZone();
	local text = "<Carto+>"..CartoPlus_SendTitle:GetText();
	text = text.."`"..MapNumber;
	text = text.."`"..CartoPlus_PointList[MapNumber][CartoPlus_Send.id].x;
	text = text.."`"..CartoPlus_PointList[MapNumber][CartoPlus_Send.id].y;
	text = text.."`"..CartoPlus_PointList[MapNumber][CartoPlus_Send.id].title;
	text = text.."`"..CartoPlus_PointList[MapNumber][CartoPlus_Send.id].expla;
	text = text.."`"..CartoPlus_PointList[MapNumber][CartoPlus_Send.id].icon.."`";
	
	Cosmos_SendMessage(text);
	CartoPlus_Send:Hide();
end

function CartoPlus_Point_SendParty()
	local MapNumber = GetCurrentMapContinent() * 100 + GetCurrentMapZone();
	local text = "<Carto+>";
	text = text..MapNumber;
	text = text.."`"..CartoPlus_PointList[MapNumber][CartoPlus_Send.id].x;
	text = text.."`"..CartoPlus_PointList[MapNumber][CartoPlus_Send.id].y;
	text = text.."`"..CartoPlus_PointList[MapNumber][CartoPlus_Send.id].title;
	text = text.."`"..CartoPlus_PointList[MapNumber][CartoPlus_Send.id].expla;
	text = text.."`"..CartoPlus_PointList[MapNumber][CartoPlus_Send.id].icon.."`";
	
	Cosmos_SendPartyMessage(text);
	CartoPlus_Send:Hide();
end

function CartoPlus_Point_Click(id)
	if (not id) then id = this:GetID(); end
	for i = 1, 16, 1 do
		if (i ~= id) then
			getglobal("CartoPlus_ModifyIcon"..i):SetChecked(0);
		else
			getglobal("CartoPlus_ModifyIcon"..i):SetChecked(1);
		end
	end
	CartoPlus_CurrentIcon = id;
end


-- HyperLink -->

function MakeHyperLink(type, name, color)
	local link = "["..name.."]";
	if (color) then
		link = "|cFF"..color.."["..name.."]|r";
	end
	return "|H"..type.."|h"..link.."|h";
end

function CartoPlus_SetItemRef(link)
	if ( strsub(link, 1, 6) == "Carto+" ) then
		local name = strsub(link, 8);
		if ( name and (strlen(name) > 0) ) then
			CartoPlus_ShowMap(name);
			return false;
		end
	end
	return true;
end
HookFunction("SetItemRef", "CartoPlus_SetItemRef", "hide");


-- Other -->

function split(s,seperator)
	local t = {};
	t.n = 0;
	for value in string.gfind(s,"[^"..seperator.."]+") do
		t.n = t.n + 1;
		t[t.n] = value;
	end
	return t;
end

function GetContinentNumber()
	local x, y = GetPlayerMapPosition("player");
	local continent = GetCurrentMapContinent();
	
	if(x == 0 and y == 0) then
		if ( continent == 1) then
			continent = 2;
		elseif( continent == 2) then
			continent = 1;
		else
			return 0;
		end
	end

	if (continent) then
		SetMapZoom(continent, nil);
	else
		return 0;
	end
	
	return 1;
end
