-- Version : English - Vjeux

IMCMD_EQUIP_COMM		= {"/equip"};
IMCMD_EQUIP_COMM_INFO	= "/equip <item name>, equips the named item";
IMCMD_UNEQUIP_COMM		= {"/unequip"};
IMCMD_UNEQUIP_COMM_INFO	= "/unequip <item name>, unequips the named item";
IMCMD_SSET_COMM			= {"/saveset"};
IMCMD_SSET_COMM_INFO	= "/saveset <number (1-4)>, saves the current equipment set";
IMCMD_LSET_COMM			= {"/loadset"};
IMCMD_LSET_COMM_INFO	= "/loadset <number (1-4)>, loads the named equipment set";
IMCMD_USE_COMM			= {"/use"};
IMCMD_USE_COMM_INFO		= "/use <item name>, uses the named item";
IMCMD_USETYPE_COMM		= {"/usetype"};
IMCMD_USETYPE_COMM_INFO	= "/usetype <item type>, uses the first item corresponding to the named type. Types are : Gem, Ore, Herb, Engineering, First Aid, Leather, Thread, Potion, Fishing, Food, Drink, Shaman, Warlock, QuestItem, Weapon, Armor, Shield, Ranged, Ammo, Clothing.";

IMCMD_ERROR_UNKITEM		= "Item '%s' not found!";
IMCMD_ERROR_NOITEM		= "There's no items corresponding to the '%s' type !";
IMCMD_ERROR_SAVED		= "Set %s saved";
IMCMD_ERROR_LOADED		= "Set %s loaded";
IMCMD_ERROR_HOLDING		= "It looks like you're already holding something.";
IMCMD_ERROR_SPACE		= "Not enough space in your bags !";


if ( GetLocale() == "frFR" ) then
	-- Traduction par Elzix

	IMCMD_EQUIP_COMM		= {"/equip"};
	IMCMD_EQUIP_COMM_INFO	= "/equip <nom de l'objet>, quipe l'objet";
	IMCMD_UNEQUIP_COMM		= {"/desequip", "/unequip"};
	IMCMD_UNEQUIP_COMM_INFO	= "/desequip <nom de l'objet>, retire l'objet";
	IMCMD_SSET_COMM			= {"/sauveset", "/saveset"};
	IMCMD_SSET_COMM_INFO	= "/sauveset <nombre (1-4)>, Enregistre l'quipement actuel dans le numro selection";
	IMCMD_LSET_COMM			= {"/chargeset", "/loadset"};
	IMCMD_LSET_COMM_INFO	= "/chargeset (1-4)>, Charge l'quipement du numro selectionn";

elseif ( GetLocale() == "deDE" ) then
	-- Translation by ??? and pc

	IMCMD_EQUIP_COMM		= {"/equip"};
	IMCMD_EQUIP_COMM_INFO	= "/equip <Gegenstandsname>, zieht den genannten Gegenstand an";
	IMCMD_UNEQUIP_COMM		= {"/unequip"};
	IMCMD_UNEQUIP_COMM_INFO	= "/unequip <Gegenstandsname>, zieht den genannten Gegenstand aus";
	IMCMD_SSET_COMM			= {"/saveset"};
	IMCMD_SSET_COMM_INFO	= "/saveset <Nummer (1-4)>, speichert das momentane Ausrstungsset";
	IMCMD_LSET_COMM			= {"/loadset"};
	IMCMD_LSET_COMM_INFO	= "/loadset <Nummer (1-4)>, ld das genannte Ausrstungsset";

end
