--[[
--
--	Thottbot Search
--
--	Allows you to submit a thottbot Search request from the game.
--
--	Alexander Brazie
--
--]]
--

function ThottbotSearch_OnLoad()
	if ( Cosmos_RegisterChatCommand ) then
		Cosmos_RegisterChatCommand(
			"COS_THOTTBOT_SEARCH",
			THOTTBOTSEARCH_REQUEST_COMMANDS,
			ThottbotSearch_Request,
			THOTTBOTSEARCH_HELP);
	end
end

function ThottbotSearch_Request(message)
	if ( message ) then 
		Sea.io.print("You are searching for ",message," on Thottbot.");
		LaunchURL(THOTTBOTSEARCH_KEY.."s="..message);
	end
end
