--[[
--	WoW Radio Request
--
--	Allows you to submit a request for a song on WoW Radio from the game.
--
--	
--
--]]
--

function WoWRadio_OnLoad()
	if ( Cosmos_RegisterChatCommand ) then
		Cosmos_RegisterChatCommand(
			"COS_WOW_RADIO",
			WOWRADIO_REQUEST_COMMANDS,
			WoWRadio_Request,
			WOWRADIO_HELP);
	end
end

function WoWRadio_Request(message)
	local realm = GetCVar("realmName");
	local name = UnitName("player");

	if ( realm and name and message ) then 
		Sea.io.print("You ("..name..")".." requested the song '",message,"' from Warcraft Radio. ");
		LaunchURL(WOWRADIO_KEY.."sv="..realm.."&".."n="..name.."&s="..message);
	end
end
